;    2.0
; (c) SysTools 2015
; http://systools.losthost.org/?misc#logoinst
;
;    Inno Setup 5.4.3 ANSI

[Setup]
AppName=
AppVersion=2.0
DefaultDirName={pf}\ 2.0
DefaultGroupName= 2.0
OutputBaseFilename=LogoInst
UninstallDisplayIcon={app}\2.exe
LicenseFile=LogoInst.txt
AllowNoIcons=yes
EnableDirDoesntExistWarning=yes
WizardImageBackColor=0
WizardImageStretch=no
;164x314
WizardImageFile=Logo_img.bmp
;55x58
WizardSmallImageFile=Logo_sml.bmp
Compression=lzma/normal
SolidCompression=yes
InfoBeforeFile=LogoInfo.txt

UserInfoPage=yes

[Languages]
Name: ru; MessagesFile: "compiler:Languages\Russian.isl"

[Messages]
BeveledLabel=(c) SysTools 2015
WelcomeLabel1=     2.0.%n    2.0   .
WelcomeLabel2=     Windows-    .%n%n  ""       .   ""   .%n%n:          .%n%n                   ,  .

WizardLicense= 
LicenseLabel=, ,   .%n    Page Down.
LicenseLabel3=      ?    "", Setup  .     2.0    .
LicenseAccepted=&,     
LicenseNotAccepted=&,      

WizardUserInfo=
UserInfoDesc=, ,    ,   CD.%n    .
UserInfoName=&:
UserInfoSerial=&:

[Types]
;     2.0,   ;  : , , -,  ,    .     60 .
Name: "mid"; Description: ""
;     2.0,  : , , -,  ,    .     300 .
Name: "max"; Description: ""
;    2.0.     5 .
Name: "min"; Description: ""
;      2.0.
Name: "cst"; Description: ""; Flags: iscustom

[Components]
;   2.0.
Name: "program"; Description: "  2.0"; Types: cst min mid max
; Flags: fixed
;    2.0.
Name: "project"; Description: "   2.0"; Types: cst mid max
;  2.0 .     2.0   .
Name: "player"; Description: " 2.0 "; Types: cst mid max
;  2.0 -.   ,   .
Name: "plugin"; Description: " 2.0 -"; Types: cst mid max
;     .
Name: "media"; Description: "    "; Types: cst mid max
;   .
Name: "movie"; Description: "  "; Types: cst max

[Files]
Source: "{code:GetPath}MW2\*"; DestDir: "{app}"; Components: program; Flags: recursesubdirs createallsubdirs external skipifsourcedoesntexist;
Source: "{code:GetPath}PROJECTS\*"; DestDir: "{app}\"; Components: project; Flags: recursesubdirs createallsubdirs external skipifsourcedoesntexist;
Source: "{code:GetPath}PLAYER\*"; DestDir: "{app}\"; Components: player; Flags: recursesubdirs createallsubdirs external skipifsourcedoesntexist;
Source: "{code:GetPath}PLUGIN\*"; DestDir: "{app}\plugin"; Components: plugin; Flags: recursesubdirs createallsubdirs external skipifsourcedoesntexist;
Source: "{code:GetPath}MEDIA\\*"; DestDir: "{app}\\"; Components: media; Flags: recursesubdirs createallsubdirs external skipifsourcedoesntexist;
Source: "{code:GetPath}MEDIA\\*"; DestDir: "{app}\\"; Components: media; Flags: recursesubdirs createallsubdirs external skipifsourcedoesntexist;
Source: "{code:GetPath}MEDIA\\*"; DestDir: "{app}\\"; Components: movie; Flags: recursesubdirs createallsubdirs external skipifsourcedoesntexist;

[Icons]
Name: "{group}\ 2.0"; Filename: "{app}\2.exe"; WorkingDir: "{app}"; Components: program
Name: "{group}\ 2.0 "; Filename: "{app}\\ .exe"; WorkingDir: "{app}\"; Components: player
Name: "{group}\ "; Filename: "{app}\\ .exe"; WorkingDir: "{app}\"; Components: program
Name: "{group}\  !"; Filename: "{app}\  !.txt"; WorkingDir: "{app}"; Components: program
Name: "{group}\  2.0"; Filename: "{uninstallexe}"

[UninstallDelete]
Type: files; Name: "{app}\owner.cfg"

[Code]
function GetLogicalDrives: DWORD; external 'GetLogicalDrives@kernel32.dll stdcall setuponly';
function GetDriveType(lpRootPathName: PChar): UINT; external 'GetDriveTypeA@kernel32.dll stdcall setuponly';
function GetFileAttributes(lpFileName: PChar): DWORD; external 'GetFileAttributesA@kernel32.dll stdcall setuponly';
function SetErrorMode(uMode: DWORD): DWORD; external 'SetErrorMode@kernel32.dll stdcall setuponly';

var diskpath: string;

function GetPath(Param: String): String;
begin
  Result:=diskpath;
end;

function FindDrive: boolean;
var
  disk, mode: DWORD;
        path: string;
begin
  mode:=SetErrorMode(1);
  path:='mw2\sprites.dll';
  diskpath:=GetCurrentDir;
  if ((diskpath[length(diskpath)]) <> '\') then diskpath:=diskpath + '\';
  if (GetFileAttributes(diskpath + path) = -1) then
  begin
    diskpath:='';
    path:='A:\' + path;
    disk:=GetLogicalDrives;
    while (disk > 0) do
    begin
      if ((disk and 1) <> 0) and (GetDriveType(copy(path, 1, 3)) = 5) and (GetFileAttributes(path) <> -1) then
      begin
        diskpath:=copy(path, 1, 3);
        break;
      end;
      path[1]:=chr(ord(path[1]) + 1);
      disk:=disk shr 1;
    end;
  end;
  SetErrorMode(mode);
  result:=(diskpath <> '');
end;

function InitializeSetup(): Boolean;
begin
  result:=FindDrive;
  if (result = false) then
    MsgBox(
      '   2.0   CD  ' + #10 +
      '       .', mbError, MB_OK);
end;

procedure OnBeveledClick(Sender: TObject);
var c: integer;
begin
  if (MsgBox('   SysTools?', mbConfirmation, MB_YESNO) = IDYES) then
    ShellExec('open', 'http://systools.losthost.org/', '', '', SW_SHOW, ewNoWait, c);
end;

procedure OnSerialEditKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key <> #8) and ((Key < '0') or (Key > '9'))) then Key:=#0;
end;

procedure InitializeWizard();
var s: string;
begin
  if (LoadStringFromFile(ExpandConstant('{code:GetPath}\license.txt'), s) = false) then
    s:=':  "license.txt"     !';
  with WizardForm.LicenseMemo do
  begin
    UseRichEdit:=False;
    RTFText:=s;
  end;
  with WizardForm.BeveledLabel do
  begin
    Enabled:=True;
    Cursor:=crHand;
    Font.Color:=clBlue;
    OnClick:=@OnBeveledClick;
  end;
  WizardForm.UserInfoSerialEdit.OnKeyPress:=@OnSerialEditKeyPress;
end;

// CheckSerial() routine located here
// but can't be published due to copyright issues
#include "LISerial.inc"

procedure CurStepChanged(CurStep: TSetupStep);
begin
  if (CurStep = ssPostInstall) then
    SaveStringToFile(
      ExpandConstant('{app}\owner.cfg'),
      Trim(ExpandConstant('{userinfoname}'))+#$20+Trim(ExpandConstant('{userinfoserial}'))+#$0D#$0A#$1A,
      False
    );
end;
